#include 	<delays.h>

#include 	"Constante.h"
#include 	"Attaque_bleu.h"
#include 	"Depart_bleu.h"							// Fonction pour la premire phase du match
#include	"Recal.h"
#include	"Distributeur.h"
#include 	"Goto_Conteneur.h"
#include 	"canon.h"
#include	"mystdio.h"
#include 	"horloge.h"



#define ADV_11 (Angle>127)
#define ADV_12 (Angle>175)
#define ADV_13 (Angle>180)

#define ADV_21 (Angle<=127)
#define ADV_22 (Angle<=80)
#define ADV_23 (Angle<=70)

// --------------------------------------------------------------------------
/*
 * attaque les balles adverses
*/
void Attaque_Bleu (void)
{




	unsigned int	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux

	char 			propuls;
	char 			ismoving=0;
	char			transition=1;								// 0 : pas de transit  ; 1 : transition avec Stop_Propulsion() ; 2 : transition sans Stop_Propulsion()
	char			adv_devant=0;
	char			adv_derriere=0;
	char			flag_AR=-1;
	float 			Beta;
	int				X, Psi;
	int 			ret;
	long int		Xrobot;											// On lit la position du robot
	long int		Yrobot;
	long int		Distance_Cible;
	int				NbEvit=0;
	int 			Angle;

	while( 1 ){
		if( transition )
			print_strint( ">ATK=", etat, 1 );

		// mise  jour des nouvelles conditions de transition :
		propuls = Etat_Propulsion();
		ismoving = propuls!='a' && propuls!='g' && propuls!='o' ;

		adv_devant = Adversaire_Devant();					// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		adv_derriere = Adversaire_Derriere();				// Mesure si le robot adverse se trouve potentiellement sur la trajectoire

		if( transition==1 && etat!=210 && etat!=310)		// Ne pas arrter les moteurs entre les changements de vitesse
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}





		Delay100TCYx(1);										// Attente entre deux cycles

		switch (etat){

// --------------------------------------------------- Dplacement normal au conteneur


			case  0:

				Xrobot=X_Propulsion();																// On lit la position du robot
				Yrobot=Y_Propulsion();
				Distance_Cible=(1500-Xrobot)*(1500-Xrobot)+(1700-Yrobot)*(1700-Yrobot);		// Calcule la distance entre le robot et la cible

				if (transition ){
					GotoXY_Propulsion(1500,1700,-80);
					transition = 0;
				}
				else if  ((adv_derriere>=2 || propuls=='g') && Distance_Cible<1000000 ){
					transition=1;
					etat = 50;
				}
				else if ((adv_derriere>=2 || propuls=='g') && Distance_Cible>=1000000 ){
					transition = 1;
					etat = 1;
				}
				else if (propuls=='a'){
					transition = 1;
					etat = 10;
				}
				break;

			case 1:
				NbEvit++;
				Evite_Robot_Adverse(NbEvit);
				transition = 1;
				etat = 0;
				break;


			case 10:
				if( transition ){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 11;
				}
				break;

			case 11:
				Angle=Angle_Robot_Adverse();
				if (transition) {
					transition=0;
					if(Recal_Arriere())
						Force_Propulsion(X_Propulsion(),2035,-1571);
					else if (flag_AR==-1)
					{
						etat=50;
						transition=1;
					}
				}
				else if (Distance_Robot_Adverse()==0 ||			// si adversaire en zone 2
						 ADV_13 || (ADV_21 && !ADV_23 && flag_AR==-1)) {
					transition=1;
					etat=201;
				}
				else if (Angle<=85) {							// si adversaire en zone 4
					transition=1;
					etat=301;
				}
				break;


// ------------------------------------------------------ vitement robot adverse

			case 50:

				Psi=A_Propulsion();
				Beta=Angle_Absolu_Robot_Adverse();

				if(		(Psi>(-1000*PI/2.000) && Psi<(1000*PI/2.000)) &&
						(Beta>(-PI/2.000) && Beta<(PI/2.000)) ){
					transition=1;
					etat=70;
				}
				else if(	!(Psi>-1000*PI/2.000 && Psi<1000*PI/2.000) &&
							 (Beta>-PI/2.000 && Beta<PI/2.000) ){
					transition=1;
					etat=60;
				}
				else if(	 (Psi>-1000*PI/2.000 && Psi<1000*PI/2.000) &&
							!(Beta>-PI/2.000 && Beta<PI/2.000) ){
					transition=1;
					etat=80;
				}
				else {
					transition=1;
					etat=90;
				}
				break;


			case 60:
				if( transition ){
					GotoXY_Propulsion(500,Y_CONTENEUR,+100);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 100;
				}else if ( propuls=='g' ){
					transition = 1;
					etat = 70;
				}
				break;

			case 70:
				if( transition ){
					GotoXY_Propulsion(500,Y_CONTENEUR,-100);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 100;
				}else if ( propuls=='g' ){
					transition = 1;
					etat = 60;
				}
				break;


			case 80:
				if( transition ){
					GotoXY_Propulsion(2500,Y_CONTENEUR,+100);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 100;
				}else if ( propuls=='g' ){
					transition = 1;
					etat = 90;
				}
				break;


			case 90:
				if( transition ){
					GotoXY_Propulsion(2500,Y_CONTENEUR,-100);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 100;
				}else if ( propuls=='g' ){
					transition = 1;
					etat = 80;
				}
				break;


			case 100:
				if( transition ){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 101;
				}
				break;


			case 101:
				if (Recal_Arriere())
					Force_Propulsion(X_Propulsion(),2035,-1571);
				transition = 1;
				etat = 110;
				break;

			case 110:
				if( transition ){
					ToutDroit_Propulsion(200,50);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 111;
				}
				break;

			case 111:
				if (X_Propulsion()<1500) {
					transition = 1;
					if( 90-Sec_depuis_debut()>30 )			// s'il reste plus de 30s
						etat = 120;
					else
						etat = 400;
				}
				else
				{
					transition = 1;
					if( 90-Sec_depuis_debut()>30 )			// s'il reste plus de 30s
						etat = 130;
					else
						etat = 500;
				}
				break;

			case 120:
				if( transition ){
					Angle_Propulsion(PI,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 121;
				}
				break;

			case 121:
				if( transition ){
					GotoXY_Propulsion(1500,1800,-60);
					transition=0;
				}
				else if( propuls=='a' ){
					transition = 1;
					etat = 10;
				}
				else if( propuls=='g' || adv_derriere>=2){
					transition = 1;
					etat = 122;
				}
				break;


			case 122:
				if( transition ){
					Stop_Propulsion();
					transition=0;
				}else if( adv_derriere<2 ){
					transition = 1;
					etat = 121;
				}
				break;


			case 130:
				if( transition ){
					Angle_Propulsion(0,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 131;
				}
				break;

			case 131:
				if( transition ){
					GotoXY_Propulsion(1500,1800,-60);
					transition=0;
				}
				else if( propuls=='a' ){
					transition = 1;
					etat = 10;
				}
				else if( propuls=='g' || adv_derriere>=2){
					transition = 1;
					etat = 132;
				}
				break;

			case 132:
				if( transition ){
					Stop_Propulsion();
					transition=0;
				}else if( adv_derriere<2 ){
					transition = 1;
					etat = 131;
				}
				break;

// --------------------------------------------- on est cal au milieu
// --------------------------------------------- aller vers le bleu puis pousser vers le rouge
			case 201:
				if( transition ){
					GotoXY_Propulsion(1000,1850,100);
					flag_AR=0;
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 202;
				}
				break;

			case 202:
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 203;
				}
				break;

			case 203:
				Angle = Angle_Robot_Adverse();
				if( transition){
					if (Recal_Arriere())
						Force_Propulsion(X_Propulsion(),2035,-1571);
					transition=0;
				}else if( 90-Sec_depuis_debut()>25 ){					// s'il reste plus de 25s
					if( !ADV_12 ){
						transition = 1;
						etat = 204;
					}
				} else {												//  s'il reste moins de 25s
					transition = 1;
					etat = 400;
				}
				break;

			case 204 :
				Pivot_Gauche();
				transition = 1;
				etat = 205;
				break;

			case 205 :
				Ejecteur_Gauche_Actif();
				Commande_Rouleaux(90, -120);
				flag_AR++;
				transition = 1;
				etat = 206;
				break;

			case 206 :
				if( transition ){
					GotoXY_Propulsion(3000,Y_Propulsion(),80);
					transition=0;
				}else if( adv_devant>=2 ) { //|| propuls=='g' ){
					transition = 1;
					etat = 207;
				}else if( X_Propulsion()>2300 ){
					transition = 2;
					etat = 210;
				}
				break;

			case 207:
				if (adv_devant<2) {
					transition = 1;
					etat = 206;
				}
				else if (flag_AR==1 && Sec_depuis_debut()>60) {			// c'est la 1re passe et il reste - de 30s
					transition = 1;
					etat = 251;
				} else if( flag_AR==2 && Sec_depuis_debut()>70) {		// c'est la 2me passe et il reste - de 20s
					transition = 1;
					etat = 221;
				}
				break;

			case 210 :
				if( transition ){
					GotoXY_Propulsion(3000,Y_Propulsion()+10,15);
					transition=0;
				}else if( IO_Sw_Gauche() && IO_Sw_Droit() ){
					transition = 1;
					etat = 220;
				}else if( propuls=='g' ){
					transition = 1;
					etat = 211;
				}
				break;

			case 211 :
				Direct_Propulsion(-50, 50);
				Ejecteur_Gauche_Repos();
				Delay10KTCYx(255);					// attendre 1 sec
				Polaire_Propulsion( -30, 5 );
				Delay10KTCYx(255);					// attendre 1 sec
				transition = 1;
				etat = 212;
				break;

			case 212:
				if( transition ){
					Angle_Propulsion(0,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 213;
				}
				break;

			case 213 :
				ret = Recal_Avant();

				if( ret )							// si recal, aller en 213
					etat = 220;
				else								// sinon, recommencer (aller en 211)
					etat = 211;
				transition = 1;

				break;

			case 220 :
				Force_Propulsion(2766, Y_Propulsion()+10, 0 );
				transition = 1;
				etat = 221;
				break;

			case 221 :
				Direct_Propulsion(-50, 50);
				Ejecteur_Gauche_Repos();
				Delay10KTCYx(255);
				Stop_Propulsion();
				transition = 1;
				etat = 222;

			case 222 :
				Polaire_Propulsion( -30, 5 );
				Delay10KTCYx(250);					// attendre 1 sec
				Commande_Rouleaux( -90, -90 );

				if( flag_AR==1 )
					etat = 302;
				else if( flag_AR==2 )
					etat = 111;
				else ;
				transition = 1;
				break;


// --------------------------------------------- reste - de 30s : pousse d'urgence vers le ct bleu
			case 251 :
				Direct_Propulsion(-50, 50);			// relever le doigt
				Ejecteur_Gauche_Repos();
				Delay10KTCYx(255);
				Stop_Propulsion();
				transition = 1;
				etat = 252;

			case 252 :
				Polaire_Propulsion( -30, 5 );		// s'carter du bord
				Delay10KTCYx(250);					// attendre 1 sec
				Commande_Rouleaux( -90, -90 );
				transition = 1;
				etat = 253;
				break;

			case 253:
				if( transition ){
					Angle_Propulsion(-PI/2,30);		// s'orienter perpendiculairement au bord
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 254;
				}
				break;

			case 254:								// se recaler contre le bord
				if (Recal_Arriere())
					Force_Propulsion(X_Propulsion(),2035,-1571);
				transition=1;
				etat = 255;
				break;

			case 255 :								// tourner vers le ct bleu
				Pivot_Droite();
				transition = 1;
				etat = 256;
				break;

			case 256 :								// reculer jusqu' l'adversaire
				if( transition ){
					GotoXY_Propulsion(2500,Y_Propulsion()+10,-40);
					transition=0;
				}else if( propuls=='g' || adv_derriere>=3 ){
					transition = 1;
					etat = 305;
				}
				break;







// --------------------------------------------- on est cal au milieu
// --------------------------------------------- aller vers le rouge puis pousser vers le bleu
			case 301:
				if( transition ){
					GotoXY_Propulsion(2000,1850,100);
					transition=0;
					flag_AR=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 302;
				}
				break;

			case 302:
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 303;
				}
				break;

			case 303:
				Angle = Angle_Robot_Adverse();
				if( transition){
					if (Recal_Arriere())
						Force_Propulsion(X_Propulsion(),2035,-1571);
					transition=0;
				}else if( 90-Sec_depuis_debut()>25 ){					// s'il reste plus de 25s
					if( !ADV_22 ){
						transition = 1;
						etat = 304;
					}
				} else {												//  s'il reste moins de 25s
					transition = 1;
					etat = 500;
				}
				break;

			case 304 :
				Pivot_Droite();
				transition = 1;
				etat = 305;
				break;

			case 305 :
				Ejecteur_Droit_Actif();
				Commande_Rouleaux(-120, 90);
				flag_AR++;
				transition = 1;
				etat = 306;
				break;

			case 306 :
				if( transition ){
					GotoXY_Propulsion(0,Y_Propulsion()+10,80);

					transition=0;
				}else if( adv_devant>=2 ) { //|| propuls=='g' ){
					transition = 1;
					etat = 307;
				}else if( X_Propulsion()<700 ){
					transition = 2;
					etat = 310;
				}
				break;

			case 307:
				if (adv_devant<2) {
					transition = 1;
					etat = 306;
				}
				else if (flag_AR==1 && Sec_depuis_debut()>60) {
					transition = 1;
					etat = 321;
				}
				break;

			case 310 :
				if( transition ){
					GotoXY_Propulsion(0,Y_Propulsion()+10,15);
					transition=0;
				}else if( IO_Sw_Gauche() && IO_Sw_Droit() ){
					transition = 1;
					etat = 320;
				}else if( propuls=='g' ){
					transition = 1;
					etat = 311;
				}
				break;

			case 311 :
				Direct_Propulsion( 50, -50 );
				Ejecteur_Droit_Repos();
				Delay10KTCYx(255);					// attendre 1 sec
				Polaire_Propulsion( -30, -5 );
				Delay10KTCYx(255);					// attendre 1 sec
				transition = 1;
				etat = 312;
				break;

			case 312:
				if( transition ){
					Angle_Propulsion(PI,30);
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 313;
				}
				break;

			case 313 :
				ret = Recal_Avant();

				if( ret )							// si recal, aller en 213
					etat = 320;
				else								// sinon, recommencer (aller en 211)
					etat = 311;
				transition = 1;

				break;

			case 320 :
				Force_Propulsion(234, Y_Propulsion(), 3141 );
				transition = 1;
				etat = 321;
				break;

			case 321 :
				Direct_Propulsion( 50, -50 );
				Ejecteur_Droit_Repos();
				Delay10KTCYx(255);
				Stop_Propulsion();
				transition = 1;
				etat = 322;

			case 322 :
				if( transition ){
					Polaire_Propulsion( -30, -5 );
					Delay10KTCYx(250);					// attendre 1 sec
					Commande_Rouleaux( -90, -90 );
					if( flag_AR==1 )
						etat = 202;
					else if( flag_AR==2 )
						etat = 111;
					else ;
					transition = 1;
				}
				break;


// ------------------------------------------------ fin du match : on est de notre ct ; dpose chez nous

			case 400 :
				transition=1;
				if( X_Propulsion()>700 )							// si on n'est pas assez du ct bleu
					etat = 401;
				else if( !IO_Sw_Gauche() || !IO_Sw_Droit() )		// si on n'est pas recal
					etat = 402;
				else 												// sinon, on est bien plac pour dposer
					etat = 404;

//				print_strint("next=", etat, 1);
//				Joy_Click();
				break;

			case 401 :
				if( transition ){
					GotoXY_Propulsion(700, 1850, 100);
					transition = 0;
				}else if( !ismoving || adv_devant>=2 ){
					transition = 1;
					etat = 402;
				}
				break;

			case 402 :
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 403;
				}
				break;

			case 403:
				if( transition ){
					if (Recal_Arriere())
						Force_Propulsion(X_Propulsion(),2035,-1571);
					transition = 0;
				} else if( Sec_depuis_debut()>80 ){						// si moins de 10s, dposer
					transition=1;
					etat = 404;
				}
				break;

			case 404 :
				if( transition ){
					DeposeBalle_Chez_Nous_Barillet();
					Delay10KTCYx(250);
					transition = 0;
				} else if( !Barillet_Busy() ){
					transition = 1;
					etat = 405;
				}
				break;

			case 405 :
				if( transition ){
					GotoXY_Propulsion(1300, 1850, 80);
					transition = 0;
				}else if( !ismoving || adv_devant>=3 ){
					transition = 1;
					etat = 406;
				}
				break;

			case 406 :
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 407;
				}
				break;

			case 407:
				if (Recal_Arriere())
					Force_Propulsion(X_Propulsion(),2035,-1571);
				transition=1;
				etat = 1000;
				break;



// ------------------------------------------------ fin du match : on est du ct adverse

			case 500 :
				Angle = Angle_Robot_Adverse();
				if( ADV_22 ){										// si l'adversaire est chez nous
					if( X_Propulsion()<2300 )						// si on n'est pas assez du ct rouge
						etat = 501;
					else if( !( IO_Sw_Gauche() && IO_Sw_Droit() ) )	// si on n'est pas recal
						etat = 502;
					else 											// sinon, on est bien plac pour dposer
						etat = 504;
				}
				else
					etat = 400;										// si l'adversaire n'est pas chez nous

				break;
				transition =  1;
				break;

			case 501 :
				if( transition ){
					GotoXY_Propulsion(2300, 1850, 100);
					transition = 0;
				}else if( !ismoving || adv_devant>=2 ){
					transition = 1;
					etat = 502;
				}
				break;

			case 502 :
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 503;
				}
				break;

			case 503:
				if( transition ){
					if (Recal_Arriere())
						Force_Propulsion(X_Propulsion(),2035,-1571);
					transition = 0;
				} else if( Sec_depuis_debut()>80 ){						// si moins de 10s, dposer
					transition=1;
					etat = 504;
				}
				break;

			case 504:
				if( transition ){
					DeposeBalle_Adverse_Barillet();
					Delay10KTCYx(250);
					transition = 0;
				} else if( !Barillet_Busy() ){
					transition = 1;
					etat = 505;
				}
				break;

			case 505 :
				if( transition ){
					GotoXY_Propulsion(1700, 1850, 80);
					transition = 0;
				}else if( !ismoving || adv_devant>=3 ){
					transition = 1;
					etat = 506;
				}
				break;

			case 506 :
				if( transition ){
					Angle_Propulsion(-PI/2,30);
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 507;
				}
				break;

			case 507:
				if (Recal_Arriere())
					Force_Propulsion(X_Propulsion(),2035,-1571);
				transition=1;
				etat = 1000;
				break;



// ----------------------------------------------  tat final

			case 1000:
				break;

			default : // pas normal : quitter
				etat = 254;

		} // fin switch()

	} //fin while(etat<254)
}



// --------------------------------------------------------------------------
/* Permet de faire un pivot  droite
 *  Pas de paramtre
*/
void Pivot_Droite(void)
{
	Direct_Asservi_Propulsion (15,-5);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()>-2241);

	Direct_Asservi_Propulsion (10,-5);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()>-2841);

	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	Angle_Propulsion (PI,10);
	while(Etat_Propulsion()!='a');
}



// --------------------------------------------------------------------------
/* Permet de faire un pivot  gauche
 *  Pas de paramtre
*/
void Pivot_Gauche(void)
{
	Direct_Asservi_Propulsion (-5,15);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()<-900);

	Direct_Asservi_Propulsion (-5,10);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()<-300);

	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	Angle_Propulsion (0,10);
	while(Etat_Propulsion()!='a');
}





